/*
 * Copyright (c) 2000 Blue Mug, Inc.  All Rights Reserved.
 */
#ifndef _SHOEHORN_SERIAL_H
#define _SHOEHORN_SERIAL_H

extern int serial_open(const char *dev);
extern int serial_close(void);
extern int serial_baud(int baud);

extern void serial_terminal(void);

extern unsigned char get_char(void);
extern int get_char_timeout(int msecs);
extern int put_char(unsigned char c);

extern unsigned long get_word(void);
extern int put_word(unsigned long w);
extern int put_block(const unsigned char *buf, int size);

extern unsigned char target_read_byte(unsigned long addr);
extern int target_write_byte(unsigned long addr, unsigned char data);
extern unsigned long target_read_word(unsigned long addr);
extern int target_write_word(unsigned long addr, unsigned long data);
extern int target_write_block(unsigned long addr, const unsigned char *buf,
			       int size, int progress);

extern int read_serial(u8 *buf, u32 size, u32 timeout_ms);
extern int write_serial(u8 *buf, u32 size, u32 interval_us);
extern int write_serial_byte(u8 data, u32 interval_us);

#endif /* _SHOEHORN_SERIAL_H */
